	org	$3000  ;(4kB space to $3FFF)

	; here's more space on the real Pac-Man cartridge
	; continue here on real cart

intermission.real:	

	; choose right animation and run it

	SETISAR	LEVEL_NUMBER_REG
	lr	A, S
	ci	3
	bz	intermission.real.first
	ci	6
	bz	intermission.real.second.jump
	ci	10
	bz	intermission.real.third.jump
	ci	14
	bz	intermission.real.third.jump
	ci	18
	bz	intermission.real.third.jump

	; we shouldn't get here
	jmp	intermission.delay.before.restart


intermission.real.second.jump
	jmp	intermission.real.second
intermission.real.third.jump
	jmp	intermission.real.third





intermission.real.first:


	; play music

	dci	music.intermission
	pi	playSong


	; Pac-Man enters from the right
	; start x coordinate: 108
	; y-coordinate 25

	; runs six pixels into screen and the ghost follows
	; after both have left screen ghosts enter from
	; left - blue - a large Pac-Man chases over the
	; entire screen... 


intermission.real.first.setup:

	SETISAR	PACMAN_X_REG
	li	108		; x coordinate
	lr	I, A		
	li	25		; y coordinate
	lr	I, A
	lis	%0010		; direction left
	lr	I, A
	lis	0   
	lr	I, A		; animation index

	; GHOST_TMP_REG

	li	109		; x coordinate
	lr	I, A
	li	25		; y coordinate
	lr	I, A
	lis	0		
	lr	I, A		; skip direction
	; animation index
	lr	S, A


intermission.1.loop.1:

;	lis	2
; 	lr	7, A

	pi	pacman.draw


	; check for ghost start
	SETISAR	PACMAN_X_REG
	lr	A, S						; set to Pac-Man X-register
	ci	101						; what's 101 - A?
	bm	intermission.1.skip.ghost.draw		; negative means ghost have to wait


	; ghost is drawn
	

	; decrease x coordinate

	SETISAR	GHOST_TMP_REG
	lr	A, S
	ai	$FF
	lr	S, A
	ci	$FA
	bz	intermission.2				; ghost has left screen, continue with second part


	; load sprite color
	li	red
	lr	1, A
	; load x coordinate
	lr	A, I
	lr	2, A
	; load y coordinate
	lr	A, I
	lr	3, A
	; load sprite number
	lr	A, I
	lr	A, S						; skip direction
	inc
	ni	%1
	lr	S, A
	ai	17
	lr	4, A
	; draw the sprite
	pi	sprite.draw


intermission.1.skip.ghost.draw:

	li	12
	lr	5, A
	pi	delay
	
	
im.pacman.clear:


	; erase large Pac-Man shadow
	
	; set correct data for blit

	li	clear
	lr	1, A
	li	bkg
	lr	2, A
	SETISAR	PACMAN_X_REG
	lr	A, I
	ai	3
	lr	3, A
	lr	A, I
	lr	4, A
	lis	2			; size
	lr	5, A
	lis	5
	lr	6, A

	dci	gfx.pac_erase.data

	pi	blit


	; decrease pac-man x coordinate, check boundaries

	SETISAR	PACMAN_X_REG
	lr	A, S				; decrease X-reg
	ai	$FF
	lr	S, A
	ci	$FA
	bnz	intermission.1

	; stop Pac-Man, wait for ghost

	li	$FB
	lr	S, A	


intermission.1:


	; clear ghost

	; load the maze's bgcolor
	li	MAZE_BGCOLOR
	lr	1, A
	SETISAR	GHOST_TMP_REG
	; load x coordinate
	lr	A, I
	lr	2, A
	; load y coordinate
	lr	A, S
	lr	3, A
	; load sprite number (0, clear)
	clr
	lr	4, A
	; draw the sprite
	pi	sprite.draw



	; update Pac-Man animation index
	SETISAR	PACMAN_ANIMINDEX_REG
	lr	A, S
	inc
	ni	%00000011
	lr	S, A

	; continue as usual

	; draw again

	br	intermission.1.loop.1








intermission.2:

	; play music

	dci	music.intermission
	pi	playSong


	; setup

	SETISAR	PACMAN_X_REG
	li	$FC		; x coordinate
	lr	I, A		
	li	22		; y coordinate
	lr	I, A
	lr	I, A		; skip direction
	lis	0   
	lr	I, A		; animation index

	; GHOST_TMP_REG

	li	$FA		; x coordinate
	lr	I, A
	li	25		; y coordinate
	lr	I, A
	lis	0		
	lr	I, A		; skip direction
	; animation index
	lr	S, A


	




	; blue ghost enters from left



intermission.2.loop:


	; decrease x coordinate

	SETISAR	GHOST_TMP_REG
	lr	A, S
	inc
	lr	S, A
	ci	110
	bnz	intermission.2.check
	li	109
	lr	S, A						; stop ghost
	br	intermission.2.draw.pacman
intermission.2.check:
	ci	15						; 15 - A
	bp	intermission.2.skip.pacman		; skip Pac-Man update for a while


intermission.2.draw.pacman:

	; update Pac-Man x coordinate
	SETISAR	PACMAN_X_REG
	lr	A, S
	inc
	lr	S, A
	ci	110
	bnz	intermission.2.draw.pacman.update.anim

	jmp	intermission.delay.before.restart

intermission.2.draw.pacman.update.anim:
	; update Pac-Man animation index
	lisl	3				; set animation index
	lr	A, S
	inc	
	ni	%00000011
	lr	S, A


	; draw large Pac-Man


	; data for blit

	; r1 = color 1 (off)
	; r2 = color 2 (on)
	; r3 = x position
	; r4 = y position
	; r5 = width
	; r6 = height (and vertical counter)
	;
	; DC = pointer to graphics


	; set correct data for blit

	li	bkg			; off color is background
	lr	1, A			
	li	green			; on color is green
	lr	2, A
	SETISAR	PACMAN_X_REG
	lr	A, I	
	lr	3, A			; x coordinate
	lr	A, I
	lr	4, A			; y coordinate
	lis	11			; size
	lr	5, A
	lr	6, A
	lr	A, I			; skip direction
	lr	A, S			; animation index


	; set correct large Pac-Man sprite

	ci	1
	bz	intermission.2.draw.pacman.closed
	ci	2
	bz	intermission.2.draw.pacman.open3
	ci	3
	bz	intermission.2.draw.pacman.open2

	dci	gfx.largepac_open1_bw.bmp.data
	br	intermission.2.draw.pacman.draw

intermission.2.draw.pacman.closed:
	dci	gfx.largepac_close_bw.bmp.data
	br	intermission.2.draw.pacman.draw
intermission.2.draw.pacman.open3:
	dci	gfx.largepac_open3_bw.bmp.data
	br	intermission.2.draw.pacman.draw
intermission.2.draw.pacman.open2:
	dci	gfx.largepac_open2_bw.bmp.data



intermission.2.draw.pacman.draw:
	pi	blit


intermission.2.skip.pacman:

	SETISAR	GHOST_TMP_REG
	; load sprite color
	li	blue
	lr	1, A
	; load x coordinate
	lr	A, I
	lr	2, A
	; load y coordinate
	lr	A, I
	lr	3, A
	; load sprite number
	lr	A, I
	lr	A, S						; skip direction
	inc
	ni	%1
	lr	S, A
	ai	24
	lr	4, A
	; draw the sprite
	pi	sprite.draw

	
	; delay
	
	lis	10
	lr	5, A
	pi	delay






	; clear ghost

	; load the maze's bgcolor
	li	MAZE_BGCOLOR
	lr	1, A
	SETISAR	GHOST_TMP_REG
	; load x coordinate
	lr	A, I
	lr	2, A
	; load y coordinate
	lr	A, S
	lr	3, A
	; load sprite number (0, clear)
	clr
	lr	4, A
	; draw the sprite
	pi	sprite.draw



	; erase large Pac-Man shadow
	
	; set correct data for blit

	li	clear
	lr	1, A
	li	bkg
	lr	2, A
	SETISAR	PACMAN_X_REG
	lr	A, I
	ai	$FF
	lr	3, A
	lr	A, I
	ai	3
	lr	4, A
	lis	1			; size
	lr	5, A
	lis	5
	lr	6, A

	dci	gfx.largepac_erase.data

	pi	blit





	jmp	intermission.2.loop




















intermission.real.second:

	; Pac-Man enters from the right
	; start x coordinate: 108
	; y-coordinate 25

	; runs six pixels into screen and the ghost follows
	; after both have left screen ghosts enter from
	; left - blue - a large Pac-Man chases over the
	; entire screen... 



intermission.real.second.setup:



	; plot spike

	li	blue
	lr	1, A
	li	55
	lr	2, A
	li	30
	lr	3, A
	
	pi	plot


	; play music

	dci	music.intermission
	pi	playSong





	SETISAR	PACMAN_X_REG
	li	108		; x coordinate
	lr	I, A		
	li	25		; y coordinate
	lr	I, A
	lis	%0010		; direction left
	lr	I, A
	lis	0   
	lr	I, A		; animation index

	; GHOST_TMP_REG

	li	109		; x coordinate
	lr	I, A
	li	25		; y coordinate
	lr	I, A
	lis	0		
	lr	I, A		; skip direction
	; animation index
	lr	S, A


intermission.second.loop.1:

	pi	pacman.draw


	; check for ghost start
	SETISAR	PACMAN_X_REG
	lr	A, S							; set to Pac-Man X-register
	ci	50							; what's 95 - A?
	bm	intermission.second.skip.ghost.draw.jump	; negative means ghost have to wait


	; drawing ghost

	; decrease x coordinate

	SETISAR	GHOST_TMP_REG
	lr	A, S
	ai	$FF
	lr	S, A
	ci	43						; 43 -A
	bp	intermission.second.stuck.still
	ci	50						; 50 - A
	bp	intermission.second.stuck			; ghost has hit spike, continue with second part


	; load sprite color
	li	red
	lr	1, A
	; load x coordinate
	lr	A, I
	lr	2, A
	; load y coordinate
	lr	A, I
	lr	3, A
	; load sprite number
	lr	A, I
	lr	A, S						; skip direction
	inc
	ni	%1
	lr	S, A
	ai	17
	lr	4, A
	; draw the sprite
	pi	sprite.draw

intermission.second.skip.ghost.draw.jump:
	jmp	intermission.second.skip.ghost.draw


intermission.second.stuck.still:
	SETISAR	GHOST_TMP_REG
	li	44
	lr	S, A

intermission.second.stuck:
	
	; blit other frames of animation

	li	bkg
	lr	1, A
	li	red
	lr	2, A
	SETISAR	GHOST_TMP_REG
	lr	A, S
	lr	3, A
	li	25
	lr	4, A
	; height
	lis	5
	lr	6, A


	SETISAR	GHOST_TMP_REG
	lr	A, S
	ci	44	
	bz	intermission.second.blit.6
	ci	45
	bz	intermission.second.blit.5
	ci	46
	bz	intermission.second.blit.4
	ci	47
	bz	intermission.second.blit.3
	ci	48
	bz	intermission.second.blit.2
	ci	49
	bz	intermission.second.blit.1
	
intermission.second.blit.0:	
	lis	6
	lr	5, A
	dci	gfx.ghost.stuck.0
	br	intermission.second.blit.draw

intermission.second.blit.1:
	lis	7
	lr	5, A
	dci	gfx.ghost.stuck.1
	br	intermission.second.blit.draw

intermission.second.blit.2:
	lis	8
	lr	5, A
	dci	gfx.ghost.stuck.2
	br	intermission.second.blit.draw

intermission.second.blit.3:
	lis	9
	lr	5, A
	dci	gfx.ghost.stuck.3
	br	intermission.second.blit.draw

intermission.second.blit.4:
	lis	10
	lr	5, A
	dci	gfx.ghost.stuck.4
	pi	blit

	li	30
	lr	5, A
	pi	delay
	br	intermission.second.skip.ghost.draw

intermission.second.blit.5:
	lis	11
	lr	5, A
	dci	gfx.ghost.stuck.5
	pi	blit

	li	70
	lr	5, A
	pi	delay
	br	intermission.second.skip.ghost.draw


intermission.second.blit.6:
	lis	12
	lr	5, A
	dci	gfx.ghost.stuck.6a

intermission.second.blit.draw.done:

	pi	blit

	; last frame drawn
	
	; draw blue part

	li	bkg
	lr	1, A
	li	green
	lr	2, A
	li	47
	lr	3, A
	li	28
	lr	4, A
	lis	2
	lr	5, A
	lr	6, A

	dci	gfx.ghost.stuck.6b

	pi	blit


	; play music

	dci	music.intermission
	pi	playSong
	
	
	jmp	intermission.delay.before.restart


		
intermission.second.blit.draw:
	pi	blit


intermission.second.skip.ghost.draw:

	lis	12
	lr	5, A
	pi	delay
	
	
im.second.pacman.clear:


	pi	pacman.clear

	; decrease pac-man x coordinate, check boundaries

	SETISAR	PACMAN_X_REG
	lr	A, S				; decrease X-reg
	ai	$FF
	lr	S, A
	ci	$FA
	bnz	intermission.second.1

	; stop Pac-Man, wait for ghost

	li	$FB
	lr	S, A	


intermission.second.1:


	; clear ghost

	; load the maze's bgcolor
	li	MAZE_BGCOLOR
	lr	1, A
	SETISAR	GHOST_TMP_REG
	; load x coordinate
	lr	A, I
	lr	2, A
	; load y coordinate
	lr	A, S
	lr	3, A
	; load sprite number (0, clear)
	clr
	lr	4, A
	; draw the sprite
	pi	sprite.draw


	; update Pac-Man animation index
	SETISAR	PACMAN_ANIMINDEX_REG
	lr	A, S
	inc
	ni	%00000011
	lr	S, A

	; continue as usual

	; draw again

	jmp	intermission.second.loop.1


















intermission.real.third:


	; play music

	dci	music.intermission
	pi	playSong



	; Monster with patch chases Pac-Man, returns naked...


	; SETUP start values

	SETISAR	PACMAN_X_REG
	li	108		; x coordinate
	lr	I, A		
	li	25		; y coordinate
	lr	I, A
	lis	%0010		; animation index
	lr	I, A
	lis	0   
	lr	I, A		; animation index

	; GHOST_TMP_REG

	li	109		; x coordinate
	lr	I, A
	li	25		; y coordinate
	lr	I, A
	lis	0		
	lr	S, A		; animation index


intermission.real.third.1.loop.1:

;	lis	2
; 	lr	7, A

	pi	pacman.draw


	; check for ghost start
	SETISAR	PACMAN_X_REG
	lr	A, S						; set to Pac-Man X-register
	ci	85						; what's 85 - A?
	bm	intermission.real.third.1.skip.ghost.draw		; negative means ghost have to wait


	; ghost is drawn
	

	; decrease x coordinate

	SETISAR	GHOST_TMP_REG
	lr	A, S
	ai	$FF
	lr	S, A
	ci	$FA
	bz	intermission.real.third.2				; ghost has left screen, continue with second part




	; Multiblit information needed:

	; r1 = x position
	; r2 = y position
	; r3 = width
	; r4 = height (and vertical counter)

	; load x coordinate
	lr	A, I
	lr	1, A
	; load y coordinate
	lr	A, I
	lr	2, A
	; load correct sprite
	lis	6
	lr	3, A
	lis	5
	lr	4, A
	dci	gfx.ghost_patch1.bmp.data
	lr	A, S
	inc
	ni	%1
	lr	S, A
	bz	patch.ghost.no.change
	dci	gfx.ghost_patch2.bmp.data
patch.ghost.no.change:
	; draw the sprite
	pi	multiblit


intermission.real.third.1.skip.ghost.draw:

	li	15
	lr	5, A
	pi	delay
	
	
intermission.real.third.1.pacman.clear:


	; erase large Pac-Man shadow
	
	; set correct data for blit

	li	clear
	lr	1, A
	li	bkg
	lr	2, A
	SETISAR	PACMAN_X_REG
	lr	A, I
	ai	3
	lr	3, A
	lr	A, I
	lr	4, A
	lis	2			; size
	lr	5, A
	lis	5
	lr	6, A

	dci	gfx.pac_erase.data

	pi	blit









	; decrease pac-man x coordinate, check boundaries

	SETISAR	PACMAN_X_REG
	lr	A, S				; decrease X-reg
	ai	$FF
	lr	S, A
	ci	$FA
	bnz	intermission.real.third.1

	; stop Pac-Man, wait for ghost

	li	$FB
	lr	S, A	


intermission.real.third.1:

	; update Pac-Man animation index
	SETISAR	PACMAN_ANIMINDEX_REG
	lr	A, S
	inc
	ni	%00000011
	lr	S, A

	; continue as usual

	; draw again

	br	intermission.real.third.1.loop.1


intermission.real.third.2:


	; small delay

	li	$FF
	lr	5, A
	pi	delay

	; GHOST_TMP_REG

	li	$FA		; x coordinate
	lr	I, A
	li	25		; y coordinate
	lr	I, A		
	clr
	lr	I, A		; animation index



	; Multiblit information needed:

	; r1 = x position
	; r2 = y position
	; r3 = width
	; r4 = height (and vertical counter)


intermission.real.third.2.loop:


	; load x coordinate
	lr	A, I
	lr	1, A
	; load y coordinate
	lr	A, I
	lr	2, A
	; load correct sprite
	lis	14
	lr	3, A
	lis	4
	lr	4, A
	dci	gfx.nude_monster1.bmp.data
	lr	A, S
	inc
	ni	%1
	lr	S, A
	bz	patch.ghost.no.change2
	dci	gfx.nude_monster2.bmp.data
patch.ghost.no.change2:
	; draw the sprite
	pi	multiblit



	li	40
	lr	5, A
	pi	delay

	; increase x-coordinate

	SETISAR	GHOST_TMP_REG
	lr	A, S
	inc
	lr	S, A

	; check if we've left screen

	ci	108
	bnz	intermission.real.third.2.loop
	




	; play music

	dci	music.intermission
	pi	playSong



	jmp	intermission.delay.before.restart



	IF	0
intermission_256:

	dci	sfx.intro.0
	pi	playSong

	dci	sfx.intro.1
	pi	playSong

	dci	sfx.extraPacman
	pi	playSong	

	dci	music.intermission
	pi	playSong

	jmp	intermission.delay.before.restart

	ENDIF



	; bonus sounds playable from intro

play.sound.wacka.wacka:
	dci	pac.siren
	pi	playSong
	br	play.sound.done
play.sound.siren:
	dci	pac.eats
	pi	playSong

play.sound.done:
	jmp	main.continue







fram_routines:
			; ALL BUTTONS HELD UPON RESET resets highscore.

readbtns_hiscore:
	ins	0
	com
	lr	4, A
	li	30
debounce_hiscore: 
	ai	$ff
	bnz	debounce_hiscore
	lr	A, 4
	ni	%00001111

test_hiscore:
	ci	%00001111
	bnz	dont_erase
	; zero out enough of the score so it will be null-ified later
	jmp	main.clear.hiscore


dont_erase:
	; check if highscore is stored in RAM
	; ascii codes for HI is in memory at ram + $600, $601

	; addition FeRAM, score check, backup score three times

	dci	ram + $600
	lm				; 1 byte
	ci	$48
	bnz	second.hiscore
	lm				; 2 bytes
	ci	$49
	bnz	second.hiscore
	lm				; first byte of score
	xm				; second
	xm				; 3
	xm				; 4
	cm 				; score check number (xor of all four bytes)
	bnz	second.hiscore 	; jump to backup

	; write score to the score backup

	dci	ram + $607
	xdc
	dci	ram + $600
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st

	dci	ram + $60E
	xdc
	dci	ram + $600
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st

	jmp	main		; jump to main intro if it was OK


	; extra backup score
second.hiscore:
	dci	ram + $607
	lm
	ci	$48
	bnz	third.hiscore
	lm
	ci	$49
	bnz	third.hiscore
	lm					; 1
	xm					; 2
	xm					; 3
	xm					; 4
	cm 					; score check number (xor of all four bytes)
	bnz	third.hiscore		; not valid, next attempt
	;copy this OK score to the none OK score above and the third one

	dci	ram + $600
	xdc
	dci	ram + $607
	lm
	xdc
	st	; store 1
	xdc
	lm
	xdc
	st	; store 2
	xdc
	lm
	xdc
	st	; store 3
	xdc
	lm
	xdc
	st	; store 4
	xdc
	lm
	xdc
	st	; store 5
	xdc
	lm
	xdc
	st	; store 6
	xdc
	lm
	xdc
	st	; store 7

	dci	ram + $60E
	xdc
	dci	ram + $607
	lm
	xdc
	st	; store 1
	xdc
	lm
	xdc
	st	; store 2
	xdc
	lm
	xdc
	st	; store 3
	xdc
	lm
	xdc
	st	; store 4
	xdc
	lm
	xdc
	st	; store 5
	xdc
	lm
	xdc
	st	; store 6
	xdc
	lm
	xdc
	st	; store 7

	jmp	main


	; extra backup score
third.hiscore:
	dci	ram + $60E
	lm
	ci	$48
	bnz	main.clear.hiscore
	lm
	ci	$49
	bnz	main.clear.hiscore
	lm					; 1
	xm					; 2
	xm					; 3
	xm					; 4
	cm 					; score check number (xor of all four bytes)
	bnz	main.clear.hiscore	; not valid - clear it

	;copy this OK score to the none OK score above and the third one

	dci	ram + $600
	xdc
	dci	ram + $60E
	lm
	xdc
	st	; store 1
	xdc
	lm
	xdc
	st	; store 2
	xdc
	lm
	xdc
	st	; store 3
	xdc
	lm
	xdc
	st	; store 4
	xdc
	lm
	xdc
	st	; store 5
	xdc
	lm
	xdc
	st	; store 6
	xdc
	lm
	xdc
	st	; store 7

	dci	ram + $607
	xdc
	dci	ram + $60E
	lm
	xdc
	st	; store 1
	xdc
	lm
	xdc
	st	; store 2
	xdc
	lm
	xdc
	st	; store 3
	xdc
	lm
	xdc
	st	; store 4
	xdc
	lm
	xdc
	st	; store 5
	xdc
	lm
	xdc
	st	; store 6
	xdc
	lm
	xdc
	st	; store 7

	br	main.intro_jmp


	; no valid highscore header in RAM
	; clear the highscore and store it in RAM
main.clear.hiscore:
	; set header characters for highscore (HI ascii codes)
	dci	ram + $600
	li	$48
	st
	li	$49
	st
	clr	; score in four bytes + exor byte
	st
	st
	st
	st
	st
	li	$48
	st
	li	$49
	st
	clr	; score in four bytes + exor byte
	st
	st
	st
	st
	st
	li	$48
	st
	li	$49
	st
	clr	; score in four bytes + exor byte
	st
	st
	st
	st
	st

main.intro_jmp:
	jmp	main


copy.to.backups:
	; *********************************************************************************
	; Fe-RAM addition, copy scores to backup
	; *********************************************************************************

	; xor checksum
	dci	ram + $602
	lm	; first byte in score
	xm	; exor with second
	xm	; exor with third
	xm	; exor with fourth
	st	; store on byte after score

	dci	ram + $609
	xdc
	dci	ram + $602
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st

	dci	ram + $610
	xdc
	dci	ram + $602
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st
	xdc
	lm
	xdc
	st

	jmp	level.ended.reset.updateHS.end


;===========================================================================
; Multiblitgraphics routine
;===========================================================================


	include 	"multiblitgraphics.inc"

	include	"intermission_data.inc"
